package com.kingdee.eas.basedata.org.app;

import com.kingdee.bos.BOSException;
import com.kingdee.bos.Context;
import com.kingdee.bos.dao.IObjectPK;
import com.kingdee.bos.dao.IObjectValue;
import com.kingdee.bos.metadata.entity.SelectorItemCollection;
import com.kingdee.eas.basedata.person.PersonInfo;
import com.kingdee.eas.basedata.person.app.PersonControllerBean;
import com.kingdee.eas.common.EASBizException;
import com.kingdee.eas.custom.synctask.SyncTranForOAFacadeFactory;
import org.apache.log4j.Logger;

/**
 * @author qingwu
 * @date 2024/10/25
 * @apiNote
 */
public class PersonControllerBeanEx extends PersonControllerBean {
    private static Logger logger =
            Logger.getLogger(PersonControllerBeanEx.class);
    @Override
    protected IObjectPK _addnew(Context ctx, IObjectValue model) throws BOSException, EASBizException {
        logger.error("PersonControllerBeanEx--------------------_addnew");
        IObjectPK iObjectPK = super._addnew(ctx, model);
        PersonInfo info = (PersonInfo) model;
        String id = info.getId().toString();
        //ͬԱOA
        SyncTranForOAFacadeFactory.getLocalInstance(ctx).syncPersonToOA(id, null);
        return iObjectPK;
    }

    @Override
    protected void _update(Context ctx, IObjectPK pk, IObjectValue model) throws BOSException, EASBizException {
        super._update(ctx, pk, model);
        logger.error("PersonControllerBeanEx--------------------_update");
        //ͬ֯OA
        SyncTranForOAFacadeFactory.getLocalInstance(ctx).syncPersonToOA(pk.toString(), null);
    }

    @Override
    protected void _updatePartial(Context ctx, IObjectValue model, SelectorItemCollection selector) throws BOSException, EASBizException {
        super._updatePartial(ctx, model, selector);
        logger.error("PersonControllerBeanEx--------------------_updatePartial");
        PersonInfo info = (PersonInfo) model;
        String id = info.getId().toString();
        //ͬ֯OA
        SyncTranForOAFacadeFactory.getLocalInstance(ctx).syncPersonToOA(id, null);
    }
}
