package com.kingdee.eas.custom.messageWebService;

import com.alibaba.fastjson.JSONObject;
import com.kingdee.bos.Context;
import com.kingdee.bos.dao.ormapping.ObjectUuidPK;
import com.kingdee.eas.base.message.*;
import com.kingdee.eas.base.message.webservice.MessageWebServiceDao;
import com.kingdee.eas.base.message.webservice.WSMessage;
import com.kingdee.eas.base.message.webservice.WfrAssignMessage;
import com.kingdee.eas.base.message.webservice.WfrProcMessage;
import okhttp3.*;
import org.apache.commons.lang3.StringUtils;
import org.apache.log4j.Logger;

import java.io.FileInputStream;
import java.net.URLEncoder;
import java.text.SimpleDateFormat;
import java.util.Date;

import java.util.Properties;

/**
 * @Description OAϢ  ProcessWebService
 * @Date 2024/10/29 13:38
 * @Created by Heyuan
 */
public class OAMessageWebServiceDao implements MessageWebServiceDao {
    private static Logger logger = Logger.getLogger(OAMessageWebServiceDao.class);

    /**
     * Ϣ
     *
     * @param message
     * @return
     */
    @Override
    public boolean addMessage(WSMessage message) {
        logger.error("*********OAMessageWebServiceDao Ϣʼ**********");
        try {
            Properties prop = new Properties();
            String propPath = System.getProperty("EAS_HOME") + "/server/properties/scy/receiveOAConfig.properties";
            prop.load(new FileInputStream(propPath));
            String receiveOAPath = prop.getProperty("receiveOAPath");
            String serverName = prop.getProperty("serverName");
            if (StringUtils.isEmpty(receiveOAPath)) {
                logger.error("OAϢ,첽ϢַΪ! ļ: " + propPath);
                return false;
            }
            JSONObject params = new JSONObject();
            String syscode = prop.getProperty("syscode", "SHR");
            SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
            Date date = new Date();
            String now = sdf.format(date);
            params.put("syscode", syscode);//칹ϵͳʶ
            params.put("flowid", message.getMsgID());//ʵid
            params.put("requestname", message.getTitle());//
            MsgType type = message.getType();
            if (type != null) {
                params.put("workflowname", type.getAlias());//
            }
            String billId = message.getBillId();
            logger.error("billId: " + billId);
            StringBuilder url = new StringBuilder();
            StringBuilder redirectUrl = new StringBuilder();
            url.append(serverName).append("/shr/api/oAToSHR?redirect=");
            if (!StringUtils.isEmpty(message.getMsgID())) {
                IAssignRead assignReadIns = AssignReadFactory.getLocalInstance(message.getContext());
                AssignReadInfo assignReadInfo = assignReadIns.getAssignReadInfo(new ObjectUuidPK(message.getMsgID()));
                String assignID = assignReadInfo.getAssignID().toString();
                redirectUrl.append(serverName).append("/easweb/webviews/workflow/transferApprove.jsp?AssignmentId=")
                        .append(assignID);
            } else {
                redirectUrl.append(serverName).append("/shr/dynamic.do?uipk=shr.perself.homepage");
            }
            url.append(URLEncoder.encode(redirectUrl.toString(), "UTF-8"));
            params.put("pcurl", url);//PCַ·/ͷ
            params.put("appurl", url);//APPַ·/ͷ
            //params.put("nodename", message.get);//ƣڵƣ
            params.put("isremark", "0");//̴״̬
            params.put("viewtype", "1");//̲鿴״̬
            params.put("creator", message.getSenderNumber());//ˣԭֵ
            params.put("createdatetime", now);//ʱ
            params.put("receiver", message.getRecieveNumber());//ˣԭֵ
            params.put("receivedatetime", now);//ʱ
            //ʱֶΣͻʹ̵߳ýӿڵʱ򣬸ݴֶжǷҪݣֹ󷢵ݱ֮ǰĸ
            params.put("receivets", String.valueOf(date.getTime()));
            logger.error("addMessage -> params: " + params);
            OkHttpClient client = new OkHttpClient();
            MediaType mediaType = MediaType.parse("application/json");
            RequestBody body = RequestBody.create(mediaType, params.toString());
            Request request = new Request.Builder()
                    .url(receiveOAPath)
                    .post(body)
                    .addHeader("content-type", "application/json")
                    .build();
            Response response = client.newCall(request).execute();
            if (response.isSuccessful()) {
                String result = response.body().string();
                JSONObject jsonObject = JSONObject.parseObject(result);
                String operResult = jsonObject.getString("operResult");
                if ("1".equals(operResult)) {
                    return true;
                } else {
                    logger.error(jsonObject.getString("message"));
                }
            } else {
                logger.error("OAϢ ʱ");
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        return false;
    }

    /**
     * ɾϢ
     *
     * @param s
     * @return
     */
    @Override
    public boolean removeMessage(String s) {
        return false;
    }

    /**
     * ɾϢ
     *
     * @param s
     * @param context
     * @return
     */
    @Override
    public boolean removeMessage(String s, Context context) {
        return false;
    }

    /**
     * Ϣ
     *
     * @param s
     * @return
     */
    @Override
    public boolean updateMessage(String s) {
        return false;
    }

    /**
     * Ϣ
     *
     * @param s
     * @param context
     * @return
     */
    @Override
    public boolean updateMessage(String s, Context context) {
        return false;
    }

    /**
     * @param s
     * @param msgStatus
     * @return
     */
    @Override
    public boolean updateMessages(String s, MsgStatus msgStatus) {
        return false;
    }

    @Override
    public boolean updateMessages(String s, MsgStatus msgStatus, Context context) {
        return false;
    }

    @Override
    public boolean addInitiatorMessage(WfrProcMessage wfrProcMessage) {
        return false;
    }

    @Override
    public boolean addCompletedMessage(WfrAssignMessage wfrAssignMessage) {
        return false;
    }
}
