package com.kingdee.eas.hr.org.app;

import com.kingdee.bos.BOSException;
import com.kingdee.bos.Context;
import com.kingdee.bos.dao.IObjectPK;
import com.kingdee.eas.basedata.org.PositionInfo;
import com.kingdee.eas.common.EASBizException;
import com.kingdee.eas.custom.synctask.SyncTranForOAFacadeFactory;
import com.kingdee.util.StringUtils;
import org.apache.log4j.Logger;

/**
 * @author qingwu
 * @date 2024/10/28
 * @apiNote
 */
public class PositionOptFacadeControllerBeanEx extends PositionOptFacadeControllerBean {
    private static Logger logger = Logger.getLogger(OrgUnitOptFacadeControllerBeanEx.class);


    @Override
    protected IObjectPK _addNewPosition(Context ctx, PositionInfo info) throws BOSException, EASBizException {
        logger.error("PositionOptFacadeControllerBeanEx---------_addNewPosition");
        IObjectPK iObjectPK = super._addNewPosition(ctx, info);
        //同步岗位到OA
        SyncTranForOAFacadeFactory.getLocalInstance(ctx).syncPositionToOA(iObjectPK.toString(), null);
        return iObjectPK;

    }

    @Override
    protected void _updatePosition(Context ctx, IObjectPK pk, PositionInfo info) throws BOSException, EASBizException {
        logger.error("PositionOptFacadeControllerBeanEx---------_updatePosition");
        super._updatePosition(ctx, pk, info);
        //同步岗位到OA
        SyncTranForOAFacadeFactory.getLocalInstance(ctx).syncPositionToOA(pk.toString(), null);
    }

    /**
     * 职位移动
     *
     * @param ctx
     * @param positionInfo
     * @throws BOSException
     * @throws EASBizException
     */
    @Override
    protected void _movePosition(Context ctx, PositionInfo positionInfo) throws BOSException, EASBizException {
        logger.error("PositionOptFacadeControllerBeanEx---------_updatePosition");
        super._movePosition(ctx, positionInfo);
        String positionId = positionInfo.getId().toString();
        if (!StringUtils.isEmpty(positionId)) {
            SyncTranForOAFacadeFactory.getLocalInstance(ctx).syncPositionToOA(positionId, null);
        }


    }

    /**
     * 职位启用
     *
     * @param ctx
     * @param positionID
     * @throws BOSException
     * @throws EASBizException
     */
    @Override
    protected void _enable(Context ctx, String positionID) throws BOSException, EASBizException {
        logger.error("PositionOptFacadeControllerBeanEx---------_updatePosition");
        super._enable(ctx, positionID);
        SyncTranForOAFacadeFactory.getLocalInstance(ctx).syncPositionToOA(positionID, null);

    }

    /**
     * 职位禁用
     *
     * @param ctx
     * @param positionID
     * @throws BOSException
     * @throws EASBizException
     */
    @Override
    protected void _disable(Context ctx, String positionID) throws BOSException, EASBizException {
        logger.error("PositionOptFacadeControllerBeanEx---------_updatePosition");
        super._disable(ctx, positionID);
        SyncTranForOAFacadeFactory.getLocalInstance(ctx).syncPositionToOA(positionID, null);
    }

    /**
     * 覆蓋导入
     *
     * @param ctx
     * @param positionInfo
     * @throws BOSException
     * @throws EASBizException
     */
    @Override
    protected void _importUpdate(Context ctx, PositionInfo positionInfo) throws BOSException, EASBizException {
        super._importUpdate(ctx, positionInfo);
        String positionid = positionInfo.getId().toString();
        if (!StringUtils.isEmpty(positionid)) {
            SyncTranForOAFacadeFactory.getLocalInstance(ctx).syncPositionToOA(positionid, null);
        }
    }
}
